//***************************************************************************
//
//  Author(s)...: Orc
//
//  Target(s)...: AVR
//
//  Description.:  7-  4-   
//
//***************************************************************************
#include "indicator.h"

#ifdef OK
#define On(port, digit) port |= (1<<digit)  
#define Off(port, digit) port &= ~(1<<digit)  
#else
#define On(port, digit) port &= ~(1<<digit)  
#define Off(port, digit) port |= (1<<digit)  
#endif

// 7-  
volatile unsigned char buf[4], comma[4];

static unsigned char numba[] =
{
0b00000011, // 0
0b10011111, // 1
0b00100101, // 2
0b00001101, // 3
0b10011001, // 4
0b01001001, // 5
0b01000001, // 6
0b00011111, // 7
0b00000001, // 8
0b00001001, // 9

0b11111101, // -
0b10000011, // U
0b01001001, // S
0b11000001, // B

0b11111111  // blank
};



//***********************************************************************************
void LED7_Init(void)
{
//  
PORT_SEG_A |= (0<<PIN_SEG_A);
DDR_SEG_A |= (1<<PIN_SEG_A);

PORT_SEG_B |= (0<<PIN_SEG_B);
DDR_SEG_B |= (1<<PIN_SEG_B);
  
PORT_SEG_B |= (0<<PIN_SEG_B);
DDR_SEG_B |= (1<<PIN_SEG_B);

PORT_SEG_C |= (0<<PIN_SEG_C);
DDR_SEG_C |= (1<<PIN_SEG_C);

PORT_SEG_D |= (0<<PIN_SEG_D);
DDR_SEG_D |= (1<<PIN_SEG_D);

PORT_SEG_E |= (0<<PIN_SEG_E);
DDR_SEG_E |= (1<<PIN_SEG_E);

PORT_SEG_F |= (0<<PIN_SEG_F);
DDR_SEG_F |= (1<<PIN_SEG_F);

PORT_SEG_G |= (0<<PIN_SEG_G);
DDR_SEG_G |= (1<<PIN_SEG_G);

PORT_SEG_DP |= (0<<PIN_SEG_DP);
DDR_SEG_DP |= (1<<PIN_SEG_DP);

PORT_DIG_1 |= (0<<PIN_DIG_1);
DDR_DIG_1 |= (1<<PIN_DIG_1);

PORT_DIG_2 |= (0<<PIN_DIG_2);
DDR_DIG_2 |= (1<<PIN_DIG_2);

PORT_DIG_3 |= (0<<PIN_DIG_3);
DDR_DIG_3 |= (1<<PIN_DIG_3);

PORT_DIG_4 |= (0<<PIN_DIG_4);
DDR_DIG_4 |= (1<<PIN_DIG_4);

}

//************************************************************************
void AllOff()
{
Off(PORT_SEG_A, PIN_SEG_A);
Off(PORT_SEG_B, PIN_SEG_B);
Off(PORT_SEG_C, PIN_SEG_C);
Off(PORT_SEG_D, PIN_SEG_D);
Off(PORT_SEG_E, PIN_SEG_E);
Off(PORT_SEG_F, PIN_SEG_F);
Off(PORT_SEG_G, PIN_SEG_G);
Off(PORT_SEG_DP, PIN_SEG_DP);

//  - 
On(PORT_DIG_1, PIN_DIG_1);
On(PORT_DIG_2, PIN_DIG_2);
On(PORT_DIG_3, PIN_DIG_3);
On(PORT_DIG_4, PIN_DIG_4);
}
//************************************************************************
void DrawDigit(unsigned char sym, unsigned char dp)
{
	unsigned char data=numba[sym];
	
	if ((data & 0b10000000) == 0) On(PORT_SEG_A, PIN_SEG_A);
	if ((data & 0b01000000) == 0) On(PORT_SEG_B, PIN_SEG_B);
	if ((data & 0b00100000) == 0) On(PORT_SEG_C, PIN_SEG_C);
	if ((data & 0b00010000) == 0) On(PORT_SEG_D, PIN_SEG_D);
	if ((data & 0b00001000) == 0) On(PORT_SEG_E, PIN_SEG_E);
	if ((data & 0b00000100) == 0) On(PORT_SEG_F, PIN_SEG_F);
	if ((data & 0b00000010) == 0) On(PORT_SEG_G, PIN_SEG_G);
	if (dp) On(PORT_SEG_DP, PIN_SEG_DP);
}

//************************************************************************
void LED7_Write_number(unsigned int value, unsigned char dot)
{
  unsigned char i, s;
  unsigned char tmp;
  
  buf[0] = 14; buf[1] = 14; buf[2] = 14; buf[3] = 14; //  
  
  
  if (value < 10) s=1;
  else if (value < 100) s=2;
  else if (value < 1000) s=3;
  else s=4;
  
  if (value < 10000)
    {
  for(i = 0; i < s; i++){
    tmp = value % 10;
    buf[i] = tmp;
    value = value/10;
  }
	}
	else // OVERFLOW
	{
		buf[0] = 10; buf[1] = 10; buf[2] = 10; buf[3] = 10; //  
	}

//     buf[0] = 7; buf[1] = 8; buf[2] = 9; buf[3] = 6;

  if (dot < 4) 
	{
    for (char x=0; x<4; x++) comma[x] = 0; // 
	comma[dot]=1;
	}
    
}

//***********************************************************************
void LED7_Write_USB() //   USB
{
	buf[3] = 10; buf[2] = 11; buf[1] = 12; buf[0] = 13;
}

//***********************************************************************
void LED7_Update(unsigned char dots)
{
  static unsigned char count = 0;
  
  //  
  AllOff();
  
  if (dots) On(PORT_SEG_DP, PIN_SEG_DP); //    
  //""   
  if (count == 0) { DrawDigit(buf[0], comma[0]); Off(PORT_DIG_4,PIN_DIG_4); }
  else if (count == 1) { DrawDigit(buf[1], comma[1]); Off(PORT_DIG_3,PIN_DIG_3); }
  else if (count == 2) { DrawDigit(buf[2], comma[2]); Off(PORT_DIG_2,PIN_DIG_2); }
  else { DrawDigit(buf[3], comma[3]); Off(PORT_DIG_1,PIN_DIG_1); }
  
  
  count++;
  if (count == 4) count = 0;
}
